' "The Bomb"
' Created with QDK Pro 4.03

define game <The Bomb>
	asl-version <400>
	gametype singleplayer
	start <Bomb Room>
	game author <Marc Andersen>
	game version <Beta 0.2>
	game info <This is the second beta version of this game.|nHave much fun with it!|nYou can send questions, comments, suggestions, bug reports or anything else you want to me.|nType email to send an email to me.|n|nMarc Andersen>
	startscript {
		set numeric <time; 0>
	}
	command <email> mailto <marcandersen@mail.dk>
	verb <arm> 
end define

define options
	debug on
	panes on
	abbreviations on
end define

define synonyms
	set = arm
end define

define room <Bomb Room>
	prefix <The>
	look <This is the bomb room.>

	define object <Bomb>
		look {
			msg <This is a bomb.>
			if property <Bomb; armed> then msg <It is currently counting down. The display reads: %time%.> else msg <It is currently not counting down.>
		}
		take <You take the bomb.>
		prefix <a>
		displaytype <Object>
		article <it>
		gender <it>
		drop {
			msg <You drop the bomb.>
			if property <Bomb; armed> then {
				set numeric <drop; $rand(0; 1)$>
				if ( %drop% = 1 ) then {
					msg <As you drop it, it suddenly explodes!>
					playwav <explode.wav>
					playerlose
					timeroff <Timer> } else lose <Bomb> } else lose <Bomb>
		}
		properties <not armed>
		action <arm> {
			if not property <Bomb; armed> then {
				if got <Bomb> then {
					msg <Type number of seconds:>
					enter <time>
					set numeric <time; #time#>
					msg <The bomb is armed to %time% seconds!>
					timeron <timer>
					property <Bomb; armed>
					property <Bomb; prefix = an armed>
					} else msg <You should pick it up first!> } else msg <The bomb is already armed.>
			
			
		}
	end define

end define

define procedure <explode>
	set numeric <time; 0>
	timeroff <timer>
	playwav <explode.wav>
	msg <The bomb has exploded!>
	if got <Bomb> then {
		playerlose } else {
		msg <Luckily, you were not hit by the bomb.>
		hide <Bomb>
		timeron <new bomb> }
end define

define timer <Timer>
	interval <1>
	action {
		dec <time; 1>
		msg <%time%>
		playwav <beep.wav>
		if ( %time% <= 0 ) then do <explode>
	}
	disabled
end define

define timer <New Bomb>
	interval <30>
	action {
		msg <Suddenly, a new bomb comes out of nowhere!>
		show <Bomb>
		property <bomb; not armed>
		property <Bomb; prefix=a>
		timeroff <New Bomb>
		set numeric <time; 0>
	}
	disabled
end define

define text <intro>
Welcome to
THE BOMB!!
end define

define text <lose>
I am sorry, you got hit by the bomb, and lost the game!
end define


